# Wan VACE 14B API

> โมเดลวิดีโอ VACE 14B อเนกประสงค์: เลือกงาน (แผนที่ความลึก, ท่าทาง, อินเพนต์, เอาต์เพนต์, รีเฟรม) พร้อมอินพุตเสริมจำนวนมาก

เครื่องมือสร้างและแก้ไขวิดีโออเนกประสงค์ที่เลือกผ่าน `task`: แผนที่ความลึก, ท่าทาง, อินเพนต์, เอาต์เพนต์ หรือรีเฟรม อินพุตประกอบด้วย `video_url` ต้นทาง, วิดีโอหรือรูปภาพมาสก์, `ref_image_urls` และ URL ของเฟรมแรกและเฟรมสุดท้าย `num_frames` อยู่ระหว่าง 17 ถึง 241 และ `resolution` อยู่ระหว่าง 240p ถึง 720p เลือกตัวสุ่มตัวอย่าง unipc, dpm++ และ euler ได้

- Model id: `wan-vace-14b`
- Made by: Alibaba
- Category: Video to Video
- Output: video
- Price per second of your output video: from $0.04 / second of output video (cheapest run $0.04 (40 API credits))
- Run: `POST https://api.doitong.com/v1/run/wan-vace-14b`
- Quote: `POST https://api.doitong.com/v1/quote/wan-vace-14b`
- Docs page: https://doitong.com/th/developers/models/wan-vace-14b

## Pricing

Price: **from $0.04 / second of output video** (the lowest tier; the quote prices your exact input). Price per second of your output video: the input files are measured before the run (length, resolution, frame rate). The quote measures the same files and is exactly what the run charges.

Price by tier:

- 240p: $0.04 / second of output video
- 360p: $0.04 / second of output video
- 480p: $0.04 / second of output video
- 580p: $0.06 / second of output video
- auto: $0.08 / second of output video
- 720p: $0.08 / second of output video

The full example input below costs $0.405 = 405 API credits (5.0625 s output video × $0.08 (auto)).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.com/v1/quote/wan-vace-14b` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

Send either the canonical name or the native field name (not both). Canonical names are the same across models.

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `prompt` |  | string | yes |  |  | คำสั่งข้อความที่ใช้ควบคุมการสร้างวิดีโอ |
| `negative_prompt` |  | string | no | `letterboxing, borders, black bars, bright colors, overexposed, static, blurred details, subtitles, style, artwork, painting, picture, still, overall gray, worst quality, low quality, JPEG compression residue, ugly, incomplete, extra fingers, poorly drawn hands, poorly drawn faces, deformed, disfigured, malformed limbs, fused fingers, still picture, cluttered background, three legs, many people in the background, walking backwards` |  | พรอมต์เชิงลบที่ใช้เมื่อสร้างวิดีโอ |
| `match_input_num_frames` |  | boolean | no | `false` |  | แหล่งที่มาของจำนวนเฟรมของวิดีโอที่สร้าง: false ใช้ `num_frames` ส่วน true จะคัดลอกจำนวนเฟรมของวิดีโออินพุต |
| `num_frames` |  | integer | no | `81` | 17 – 241 | จำนวนเฟรมเอาต์พุต โดยมีช่วงรวมขอบเขต 81–241 |
| `match_input_frames_per_second` |  | boolean | no | `false` |  | แหล่งที่มาของอัตราเฟรมของวิดีโอที่สร้าง: false ใช้ `frames_per_second` ส่วน true จะคัดลอกอัตราเฟรมของวิดีโออินพุต |
| `frames_per_second` |  | integer \| null | no | `16` | 5 – 30 | อัตราเฟรมของวิดีโอที่สร้าง ใช้เฉพาะเมื่อ `match_input_frames_per_second` ไม่เป็น true ค่าที่ยอมรับได้คือ 5–30 เฟรมต่อวินาที |
| `task` |  | enum (string) | no | `depth` | `depth`, `pose`, `inpainting`, `outpainting`, `reframe` | ประเภทงานที่โมเดลทำ |
| `seed` |  | integer \| null | no |  |  | Seed ที่ทำให้การสร้างได้ผลลัพธ์ซ้ำเดิม การตั้งค่าเป็น None จะสุ่มเลือก seed |
| `resolution` |  | enum (string) | no | `auto` | `auto`, `240p`, `360p`, `480p`, `580p`, `720p` | ความละเอียดของวิดีโอเอาต์พุต |
| `aspect_ratio` |  | enum (string) | no | `auto` | `auto`, `16:9`, `1:1`, `9:16` | อัตราส่วนภาพของวิดีโอผลลัพธ์ |
| `num_inference_steps` |  | integer | no | `30` | 2 – 50 | จำนวนขั้นตอนการสุ่มตัวอย่าง ซึ่งแลกเวลาในการประมวลผลที่นานขึ้นกับคุณภาพที่ดีขึ้นเมื่อเพิ่มจำนวน |
| `guidance_scale` |  | number | no | `5` | 1 – 10 | ความแรงในการจัดแนวพรอมต์ที่ควบคุมผ่าน classifier-free guidance การเพิ่มสเกลจะช่วยให้รูปภาพที่สร้างทำตามข้อความได้ใกล้เคียงยิ่งขึ้น |
| `sampler` |  | enum (string) | no | `unipc` | `unipc`, `dpm++`, `euler` | แซมเพลอร์ที่ใช้เมื่อสร้างวิดีโอ |
| `shift` |  | number | no | `5` | 1 – 15 | การตั้งค่าการเลื่อนที่ใช้เมื่อสร้างวิดีโอ |
| `video_url` | `video` | string (video URL) \| null | no |  |  | วิดีโออ้างอิงสำหรับโมเดล โดยระบุเป็น URL ที่ชี้ไปยังไฟล์ต้นทางเมื่อมีการส่งค่า |
| `mask_video_url` |  | string (video URL) \| null | no |  |  | มาสก์อ้างอิงสำหรับโมเดล โดยระบุเป็น URL ที่ชี้ไปยังไฟล์ต้นทางเมื่อมีการส่งค่า |
| `mask_image_url` |  | string (image URL) \| null | no |  |  | มาสก์นำทางที่ระบุด้วย URL ของไฟล์ ซึ่งมีลำดับความสำคัญเหนือ URL วิดีโอมาสก์เมื่อมีการระบุ โมเดลใช้มาสก์นี้เพื่อกำกับการสร้างวิดีโอแบบมีมาสก์ |
| `ref_image_urls` |  | array of image URL | no |  |  | URL รูปภาพต้นทางที่เป็นตัวเลือก เพื่อให้โมเดลใช้เป็นรูปภาพอ้างอิง |
| `first_frame_url` | `image` | string \| null | no |  |  | ข้อมูลอ้างอิงเฟรมแรกที่ระบุเป็น URL เพื่อให้โมเดลใช้เมื่อประมวลผลวิดีโอ |
| `last_frame_url` | `end_image` | string \| null | no |  |  | ข้อมูลอ้างอิงเฟรมสุดท้ายที่ระบุเป็น URL เพื่อให้โมเดลใช้เมื่อประมวลผลวิดีโอ |
| `enable_safety_checker` |  | boolean | no | `false` |  | สวิตช์ตรวจสอบความปลอดภัย ซึ่งการตั้งค่าเป็นปิดต้องได้รับอนุญาตจากบัญชี หากไม่มีการอนุญาตดังกล่าว ทุกคำขอจะได้รับการตรวจสอบโดยไม่คำนึงถึงการตั้งค่า; true จะเปิดใช้ตัวตรวจสอบ |
| `enable_prompt_expansion` |  | boolean | no | `false` |  | ควบคุมว่าจะเปิดใช้การขยายพรอมต์หรือไม่ |
| `preprocess` |  | boolean | no | `false` |  | ควบคุมการประมวลผลล่วงหน้าของวิดีโออินพุต |
| `acceleration` |  | enum (string) \| null | no | `regular` | `none`, `low`, `regular` | การตั้งค่าการเร่งการอนุมาน โดยเลือก 'none' หรือ 'regular': การประมวลผลแบบเร่งความเร็วขึ้นอย่างมาก โดยแลกกับการเปลี่ยนแปลงเอาต์พุตเพียงเล็กน้อย |
| `video_quality` |  | enum (string) | no | `high` | `low`, `medium`, `high`, `maximum` | ระดับคุณภาพของวิดีโอผลลัพธ์ |
| `video_write_mode` |  | enum (string) | no | `balanced` | `fast`, `balanced`, `small` | โหมดการเขียนสำหรับวิดีโอผลลัพธ์ |
| `num_interpolated_frames` |  | integer | no | `0` | 0 – 5 | จำนวนการทำอินเทอร์โพเลชัน: 0 จะคงเฟรมต้นฉบับไว้โดยไม่ทำอินเทอร์โพเลชัน ค่าอื่นจะระบุจำนวนเฟรมกลางที่ต้องสร้างระหว่างเฟรมเหล่านั้น |
| `temporal_downsample_factor` |  | integer | no | `0` | 0 – 5 | ตัวคูณการข้ามเฟรมของวิดีโอ ซึ่งแสดงเป็นจำนวนเต็ม โดยจะอัปแซมปลิงอัตโนมัติหนึ่งครั้งต่อทุกตัวคูณการดาวน์แซมปลิง ใช้ 0 เพื่อปิดการดาวน์แซมปลิงตามเวลา |
| `enable_auto_downsample` |  | boolean | no | `false` |  | การปรับจำนวนเฟรมอัตโนมัติ: เมื่อเปิดใช้ โมเดลจะประมวลผลวิดีโอที่ดาวน์แซมปลิงตามเวลาและมีความยาวเหมาะสม จากนั้นทำอินเทอร์โพเลชันเพื่อคืนจำนวนเฟรมเดิม |
| `auto_downsample_min_fps` |  | number | no | `15` | 1 – 60 | อัตราเฟรมขั้นต่ำในเฟรมต่อวินาทีที่อนุญาตหลังการลดการสุ่มตัวอย่าง สำหรับฟุตเทจที่มีการเคลื่อนไหวน้อย การลดค่านี้ทำให้ลดการสุ่มตัวอย่างได้มากขึ้นและรองรับลำดับที่ยาวขึ้น ส่วนการเคลื่อนไหวที่เร็วมากอาจต้องใช้ค่าที่สูงขึ้น แม้ว่าค่าเริ่มต้นจะเหมาะกับวิดีโอส่วนใหญ่ การลดการสุ่มตัวอย่างอัตโนมัติจะใช้เกณฑ์นี้เพื่อค้นหาตัวคูณต่ำสุดที่ยังคงรายละเอียดไว้ |
| `interpolator_model` |  | enum (string) | no | `film` | `rife`, `film` | การเลือกโมเดลแทรกเฟรม: 'rife' หรือ 'film' |
| `transparency_mode` |  | enum (string) | no | `content_aware` | `content_aware`, `white`, `black` | การจัดการความโปร่งใสสำหรับเฟรมเริ่มต้นและเฟรมสิ้นสุด ซึ่งกำหนดวิธีเติมบริเวณโปร่งใส |
| `return_frames_zip` |  | boolean | no | `false` |  | ควบคุมว่าจะส่งคืนไฟล์ ZIP ที่มีเฟรมที่สร้างทั้งหมดด้วยหรือไม่ โดยเปิดใช้งานเมื่อเป็น true |

File parameters (`video`, `mask_video_url`, `mask_image_url`, `ref_image_urls`) take a public `https://` URL, a `data:` URI up to 10 MB, or the `file_url` of an upload from `POST /files`.

## Example input

Required parameters only:

```json
{
  "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
}
```

A fuller example:

```json
{
  "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.com/v1/run/wan-vace-14b?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.com/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.com/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/wan-vace-14b?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.com/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/wan-vace-14b", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.com/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "wan-vace-14b",
      "input": {
        "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "wan-vace-14b",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 405,
    "usd": "0.405",
    "charged": 405,
    "refunded": 0
  },
  "input": {
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
  },
  "output": {
    "video": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.mp4",
      "content_type": "video/mp4",
      "file_name": "0-output.mp4",
      "file_size": 1843200,
      "width": 1024,
      "height": 768,
      "fps": 1.0,
      "duration": 5,
      "num_frames": 1
    },
    "prompt": "string",
    "seed": 42,
    "frames_zip": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.mp4",
      "content_type": "video/mp4",
      "file_name": "0-output.mp4",
      "file_size": 1843200
    }
  },
  "outputs": [
    {
      "type": "video",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.mp4",
      "content_type": "video/mp4",
      "file_size": 1843200,
      "width": 1280,
      "height": 720,
      "duration": 5,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `video` | object {url, content_type, file_name, file_size, width, height, fps, duration, num_frames} | ไฟล์วิดีโอที่สร้างขึ้น |
| `prompt` | string | พรอมต์ที่ใช้สร้างเอาต์พุต |
| `seed` | integer | ค่า Seed ที่ใช้ระหว่างการสร้าง |
| `frames_zip` | object {url, content_type, file_name, file_size} \| null | ไฟล์ ZIP ที่มีเฟรมวิดีโอทั้งหมด ซึ่งจะส่งคืนเมื่อร้องขอ |

## Related models

- [Wan VACE 14B · Depth](https://doitong.com/developers/models/wan-vace-14b/depth.md) (`wan-vace-14b/depth`): from $0.04 / second of output video
- [Wan VACE 14B · Inpainting](https://doitong.com/developers/models/wan-vace-14b/inpainting.md) (`wan-vace-14b/inpainting`): from $0.04 / second of output video
- [Wan VACE 14B · Outpainting](https://doitong.com/developers/models/wan-vace-14b/outpainting.md) (`wan-vace-14b/outpainting`): from $0.04 / second of output video
- [Wan VACE 14B · Pose](https://doitong.com/developers/models/wan-vace-14b/pose.md) (`wan-vace-14b/pose`): from $0.04 / second of output video
- [Wan VACE 14B · Reframe](https://doitong.com/developers/models/wan-vace-14b/reframe.md) (`wan-vace-14b/reframe`): from $0.04 / second of output video
- [Happy Horse Video Edit](https://doitong.com/developers/models/alibaba/happy-horse/video-edit.md) (`alibaba/happy-horse/video-edit`): from $0.28 / second of input video
- [Wan 2.1 VACE Long Reframe](https://doitong.com/developers/models/wan-vace-apps/long-reframe.md) (`wan-vace-apps/long-reframe`): from $0.04 / 2 seconds of input video
- [Wan 2.2 VACE Fun A14B · Depth](https://doitong.com/developers/models/wan-22-vace-fun-a14b/depth.md) (`wan-22-vace-fun-a14b/depth`): from $0.05 / second of output video

## Links

- HTML page: https://doitong.com/developers/models/wan-vace-14b
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=wan-vace-14b
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.com/v1/models/wan-vace-14b
